﻿// Copyright 2009 Oliver Sturm <oliver@sturmnet.org> All rights reserved. 

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Variance {
  class Program {
    static void Main(string[] args) {
      // This didn't work in C# 3.0. Currently it still doesn't work, because
      // the CTP doesn't contain the modified interfaces yet that the final
      // version will have. This will work later.
      //var strings = new List<string> { "one", "two" };
      //IEnumerable<object> objects = (IEnumerable<object>) strings;

      // The reason this never worked is that you could then try to
      // write code like this - obviously not intended to work.
      //var strings = new List<string> { "one", "two" };
      //var objects = (IList<object>) strings;
      //objects.Add(42);

      // The following works, because my interface uses "out" on the type parameter
      // to specify that it can only be output from the interface. Thereby
      // T becomes covariant.
      // Note that this works only when I use the interface. The same thing
      // wouldn't work with the class type(s), because in/out can only
      // be specified on interfaces and delegates, apparently due to a CLR
      // restriction.
      var cs = new MyContainer<string>("Hi there") as IMyContainer<string>;
      var co = (IMyContainer<object>) cs;

      // Similarly, some interfaces are going to support contra-variance using
      // the keyword "in" on type parameters. The example that's usually shown
      // is that of IComparer. There don't appear to be any lists yet of 
      // interfaces that are going to use these features in the final .NET 4.0 framework.
    }
  }

  public interface IMyContainer<out T> {
    T GetValue( );
  }

  class MyContainer<T> : IMyContainer<T> {
    T value;
    public MyContainer(T value) {
      this.value = value;
    }
    T IMyContainer<T>.GetValue( ) {
      return value;
    }
  }
}
